diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/nix-vector-routing/helper/nix-vector-helper.h ns-3.35/src/nix-vector-routing/helper/nix-vector-helper.h
--- ns-3.34/src/nix-vector-routing/helper/nix-vector-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.35/src/nix-vector-routing/helper/nix-vector-helper.h	2021-10-01 13:26:47.000000000 -0700
@@ -0,0 +1,147 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2009 The Georgia Institute of Technology
+ * Copyright (c) 2021 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * 
+ * This file is adapted from the old ipv4-nix-vector-helper.h.
+ *
+ * Authors: Josh Pelkey <jpelkey@gatech.edu>
+ * 
+ * Modified by: Ameya Deshpande <ameyanrd@outlook.com>
+ */
+
+#ifndef NIX_VECTOR_HELPER_H
+#define NIX_VECTOR_HELPER_H
+
+#include "ns3/object-factory.h"
+#include "ns3/ipv4-routing-helper.h"
+#include "ns3/ipv6-routing-helper.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup nix-vector-routing
+ *
+ * \brief Helper class that adds Nix-vector routing to nodes.
+ *
+ * This class is expected to be used in conjunction with 
+ * ns3::InternetStackHelper::SetRoutingHelper
+ *
+ * \internal
+ * Since this class is meant to be specialized only by Ipv4RoutingHelper or 
+ * Ipv6RoutingHelper the implementation of this class doesn't need to be
+ * exposed here; it is in nix-vector-helper.cc.
+
+ */
+template <typename T>
+class NixVectorHelper : public std::enable_if<std::is_same<Ipv4RoutingHelper, T>::value || std::is_same<Ipv6RoutingHelper, T>::value, T>::type
+{
+  /// Alias for determining whether the parent is Ipv4RoutingHelper or Ipv6RoutingHelper
+  using IsIpv4 = std::is_same <Ipv4RoutingHelper, T>;
+  /// Alias for Ipv4 and Ipv6 classes
+  using Ip = typename std::conditional <IsIpv4::value, Ipv4, Ipv6>::type;
+  /// Alias for Ipv4Address and Ipv6Address classes
+  using IpAddress = typename std::conditional<IsIpv4::value, Ipv4Address, Ipv6Address>::type;
+  /// Alias for Ipv4RoutingProtocol and Ipv6RoutingProtocol classes
+  using IpRoutingProtocol = typename std::conditional<IsIpv4::value, Ipv4RoutingProtocol, Ipv6RoutingProtocol>::type;
+public:
+  /**
+   * Construct an NixVectorHelper to make life easier while adding Nix-vector
+   * routing to nodes.
+   */
+  NixVectorHelper ();
+
+  /**
+   * \brief Construct an NixVectorHelper from another previously
+   * initialized instance (Copy Constructor).
+   *
+   * \param o object to copy
+   */
+  NixVectorHelper (const NixVectorHelper<T> &o);
+
+  /**
+   * \returns pointer to clone of this NixVectorHelper
+   * 
+   * This method is mainly for internal use by the other helpers;
+   * clients are expected to free the dynamic memory allocated by this method
+   */
+  NixVectorHelper<T>* Copy (void) const;
+
+  /**
+  * \param node the node on which the routing protocol will run
+  * \returns a newly-created routing protocol
+  *
+  * This method will be called by ns3::InternetStackHelper::Install
+  */
+  virtual Ptr<IpRoutingProtocol> Create (Ptr<Node> node) const;
+
+  /**
+   * \brief prints the routing path for a source and destination at a particular time.
+   * If the routing path does not exist, it prints that the path does not exist between
+   * the nodes in the ostream.
+   * \param printTime the time at which the routing path is supposed to be printed.
+   * \param source the source node pointer to start traversing
+   * \param dest the IP destination address
+   * \param stream the output stream object to use
+   * \param unit the time unit to be used in the report
+   *
+   * This method calls the PrintRoutingPath() method of the
+   * NixVectorRouting for the source and destination to provide
+   * the routing path at the specified time.
+   */
+  void PrintRoutingPathAt (Time printTime, Ptr<Node> source, IpAddress dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
+
+private:
+  /**
+   * \brief Assignment operator declared private and not implemented to disallow
+   * assignment and prevent the compiler from happily inserting its own.
+   * \return Nothing useful.
+   */
+  NixVectorHelper &operator = (const NixVectorHelper &);
+
+  ObjectFactory m_agentFactory; //!< Object factory
+
+  /**
+   * \brief prints the routing path for the source and destination. If the routing path
+   * does not exist, it prints that the path does not exist between the nodes in the ostream.
+   * \param source the source node pointer to start traversing
+   * \param dest the IP destination address
+   * \param stream the output stream object to use
+   * \param unit the time unit to be used in the report
+   *
+   * This method calls the PrintRoutingPath() method of the
+   * NixVectorRouting for the source and destination to provide
+   * the routing path.
+   */
+  static void PrintRoute (Ptr<Node> source, IpAddress dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S);
+};
+
+/**
+ * \ingroup nix-vector-routing
+ * Create the typedef Ipv4NixVectorHelper with T as Ipv4RoutingHelper
+ *
+ * Note: This typedef enables also backwards compatibility with original Ipv4RoutingHelper.
+ */
+typedef NixVectorHelper<Ipv4RoutingHelper> Ipv4NixVectorHelper;
+
+/**
+ * \ingroup nix-vector-routing
+ * Create the typedef Ipv6NixVectorHelper with T as Ipv6RoutingHelper
+ */
+typedef NixVectorHelper<Ipv6RoutingHelper> Ipv6NixVectorHelper;
+} // namespace ns3
+
+#endif /* NIX_VECTOR_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.h ns-3.35/src/nix-vector-routing/model/ipv4-nix-vector-routing.h
--- ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2021-10-01 13:26:47.000000000 -0700
@@ -1,6 +1,6 @@
 /* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
- * Copyright (c) 2009 The Georgia Institute of Technology 
+ * Copyright (c) 2021 NITK Surathkal
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -15,266 +15,10 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- * Authors: Josh Pelkey <jpelkey@gatech.edu>
- */
-
-#ifndef IPV4_NIX_VECTOR_ROUTING_H
-#define IPV4_NIX_VECTOR_ROUTING_H
-
-#include "ns3/channel.h"
-#include "ns3/node-container.h"
-#include "ns3/node-list.h"
-#include "ns3/net-device-container.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/nix-vector.h"
-#include "ns3/bridge-net-device.h"
-#include "ns3/nstime.h"
-
-#include <map>
-#include <unordered_map>
-
-namespace ns3 {
-
-/**
- * \defgroup nix-vector-routing Nix-Vector Routing
+ * The purpose of this file is to have backwards compatibility with previous
+ * IPv4 Nix Vector Routing examples and usages.
  *
- * Nix-vector routing is a simulation specific routing protocol and is
- * intended for large network topologies.
- */
-
-/**
- * \ingroup nix-vector-routing
- * Map of Ipv4Address to NixVector
- */
-typedef std::map<Ipv4Address, Ptr<NixVector> > NixMap_t;
-/**
- * \ingroup nix-vector-routing
- * Map of Ipv4Address to Ipv4Route
- */
-typedef std::map<Ipv4Address, Ptr<Ipv4Route> > Ipv4RouteMap_t;
-
-/**
- * \ingroup nix-vector-routing
- * Nix-vector routing protocol
+ * Authors: Ameya Deshpande <ameyanrd@outlook.com>
  */
-class Ipv4NixVectorRouting : public Ipv4RoutingProtocol
-{
-public:
-  Ipv4NixVectorRouting ();
-  ~Ipv4NixVectorRouting ();
-  /**
-   * @brief The Interface ID of the Global Router interface.
-   * @return The Interface ID
-   * @see Object::GetObject ()
-   */
-  static TypeId GetTypeId (void);
-  /**
-   * @brief Set the Node pointer of the node for which this
-   * routing protocol is to be placed
-   *
-   * @param node Node pointer
-   */
-  void SetNode (Ptr<Node> node);
-
-  /**
-   * @brief Called when run-time link topology change occurs
-   * which iterates through the node list and flushes any
-   * nix vector caches
-   *
-   * \internal
-   * \c const is used here due to need to potentially flush the cache
-   * in const methods such as PrintRoutingTable.  Caches are stored in
-   * mutable variables and flushed in const methods.
-   */
-  void FlushGlobalNixRoutingCache (void) const;
-
-  /**
-   * @brief Print the Routing Path according to Nix Routing
-   * \param source Source node
-   * \param dest Destination node address
-   * \param stream The ostream the Routing path is printed to
-   * \param unit the time unit to be used in the report
-   */
-  void PrintRoutingPath (Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit) const;
-
-
-private:
-
-  /**
-   * Flushes the cache which stores nix-vector based on
-   * destination IP
-   */
-  void FlushNixCache (void) const;
-
-  /**
-   * Flushes the cache which stores the Ipv4 route
-   * based on the destination IP
-   */
-  void FlushIpv4RouteCache (void) const;
-
-  /**
-   * Upon a run-time topology change caches are
-   * flushed and the total number of neighbors is
-   * reset to zero
-   */
-  void ResetTotalNeighbors (void);
-
-  /**
-   * Takes in the source node and dest IP and calls GetNodeByIp,
-   * BFS, accounting for any output interface specified, and finally
-   * BuildNixVector to return the built nix-vector
-   *
-   * \param source Source node
-   * \param dest Destination node address
-   * \param oif Preferred output interface
-   * \returns The NixVector to be used in routing.
-   */
-  Ptr<NixVector> GetNixVector (Ptr<Node> source, Ipv4Address dest, Ptr<NetDevice> oif) const;
-
-  /**
-   * Checks the cache based on dest IP for the nix-vector
-   * \param address Address to check
-   * \returns The NixVector to be used in routing.
-   */
-  Ptr<NixVector> GetNixVectorInCache (Ipv4Address address) const;
-
-  /**
-   * Checks the cache based on dest IP for the Ipv4Route
-   * \param address Address to check
-   * \returns The cached route.
-   */
-  Ptr<Ipv4Route> GetIpv4RouteInCache (Ipv4Address address);
-
-  /**
-   * Given a net-device returns all the adjacent net-devices,
-   * essentially getting the neighbors on that channel
-   * \param [in] netDevice the NetDevice attached to the channel.
-   * \param [in] channel the channel to check
-   * \param [out] netDeviceContainer the NetDeviceContainer of the NetDevices in the channel.
-   */
-  void GetAdjacentNetDevices (Ptr<NetDevice> netDevice, Ptr<Channel> channel, NetDeviceContainer & netDeviceContainer) const;
-
-  /**
-   * Iterates through the node list and finds the one
-   * corresponding to the given Ipv4Address
-   * \param dest destination node IP
-   * \return The node with the specified IP.
-   */
-  Ptr<Node> GetNodeByIp (Ipv4Address dest) const;
-
-  /**
-   * Recurses the parent vector, created by BFS and actually builds the nixvector
-   * \param [in] parentVector Parent vector for retracing routes
-   * \param [in] source Source Node index
-   * \param [in] dest Destination Node index
-   * \param [out] nixVector the NixVector to be used for routing
-   * \returns true on success, false otherwise.
-   */
-  bool BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector) const;
-
-  /**
-   * Special variation of BuildNixVector for when a node is sending to itself
-   * \param [out] nixVector the NixVector to be used for routing
-   * \returns true on success, false otherwise.
-   */
-  bool BuildNixVectorLocal (Ptr<NixVector> nixVector);
-
-  /**
-   * Simply iterates through the nodes net-devices and determines
-   * how many neighbors the node has.
-   * \param [in] node node pointer
-   * \returns the number of neighbors of m_node.
-   */
-  uint32_t FindTotalNeighbors (Ptr<Node> node) const;
-
-
-  /**
-   * Determine if the NetDevice is bridged
-   * \param nd the NetDevice to check
-   * \returns the bridging NetDevice (or null if the NetDevice is not bridged)
-   */
-  Ptr<BridgeNetDevice> NetDeviceIsBridged (Ptr<NetDevice> nd) const;
-
-
-  /**
-   * Nix index is with respect to the neighbors.  The net-device index must be
-   * derived from this
-   * \param [in] node the current node under consideration
-   * \param [in] nodeIndex Nix Node index
-   * \param [out] gatewayIp IP address of the gateway
-   * \returns the index of the NetDevice in the node.
-   */
-  uint32_t FindNetDeviceForNixIndex (Ptr<Node> node, uint32_t nodeIndex, Ipv4Address & gatewayIp) const;
-
-  /**
-   * \brief Breadth first search algorithm.
-   * \param [in] numberOfNodes total number of nodes
-   * \param [in] source Source Node
-   * \param [in] dest Destination Node
-   * \param [out] parentVector Parent vector for retracing routes
-   * \param [in] oif specific output interface to use from source node, if not null
-   * \returns false if dest not found, true o.w.
-   */
-  bool BFS (uint32_t numberOfNodes,
-            Ptr<Node> source,
-            Ptr<Node> dest,
-            std::vector< Ptr<Node> > & parentVector,
-            Ptr<NetDevice> oif) const;
-
-  void DoDispose (void);
-
-  /* From Ipv4RoutingProtocol */
-  virtual Ptr<Ipv4Route> RouteOutput (Ptr<Packet> p, const Ipv4Header &header, Ptr<NetDevice> oif, Socket::SocketErrno &sockerr);
-  virtual bool RouteInput (Ptr<const Packet> p, const Ipv4Header &header, Ptr<const NetDevice> idev,
-                           UnicastForwardCallback ucb, MulticastForwardCallback mcb,
-                           LocalDeliverCallback lcb, ErrorCallback ecb);
-  virtual void NotifyInterfaceUp (uint32_t interface);
-  virtual void NotifyInterfaceDown (uint32_t interface);
-  virtual void NotifyAddAddress (uint32_t interface, Ipv4InterfaceAddress address);
-  virtual void NotifyRemoveAddress (uint32_t interface, Ipv4InterfaceAddress address);
-  virtual void SetIpv4 (Ptr<Ipv4> ipv4);
-  virtual void PrintRoutingTable (Ptr<OutputStreamWrapper> stream, Time::Unit unit = Time::S) const;
- 
-  /**
-   * Flushes routing caches if required.
-   */
-  void CheckCacheStateAndFlush (void) const;
-
-  /**
-   * Build map from IPv4 Address to Node for faster lookup.
-   */
-  void BuildIpv4AddressToNodeMap (void) const;
-
-  /**
-   * Flag to mark when caches are dirty and need to be flushed.  
-   * Used for lazy cleanup of caches when there are many topology changes.
-   */
-  static bool g_isCacheDirty;
-
-  /** Cache stores nix-vectors based on destination ip */
-  mutable NixMap_t m_nixCache;
-
-  /** Cache stores Ipv4Routes based on destination ip */
-  mutable Ipv4RouteMap_t m_ipv4RouteCache;
-
-  Ptr<Ipv4> m_ipv4; //!< IPv4 object
-  Ptr<Node> m_node; //!< Node object
-
-  /** Total neighbors used for nix-vector to determine number of bits */
-  uint32_t m_totalNeighbors;
-
-
-  /**
-   * Mapping of IPv4 address to ns-3 node.
-   *
-   * Used to avoid linear searching of nodes/devices to find a node in
-   * GetNodeByIp() method.  NIX vector routing assumes IP addresses
-   * are unique so mapping can be done without duplication.
-   **/
-  typedef std::unordered_map<Ipv4Address, ns3::Ptr<ns3::Node>, Ipv4AddressHash > Ipv4AddressToNodeMap;
-  static Ipv4AddressToNodeMap g_ipv4AddressToNodeMap; //!< Address to node map.
-};
-} // namespace ns3
-
-#endif /* IPV4_NIX_VECTOR_ROUTING_H */
+#pragma GCC warning "NS_DEPRECATED_3_35 - Deprecated header, please use nix-vector-routing.h instead"
+#include "nix-vector-routing.h"
\ No newline at end of file
